## net.sf.saxon.value
Class AnyURIValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.StringValue
                  net.sf.saxon.value.AnyURIValue

All Implemented Interfaces:
  java.io.Serializable, PullEvent, SequenceIterable, GroundedValue, Item, ValueRepresentation, ConversionResult

    public final class AnyURIValue

extends StringValue

An XPath value of type xs:anyURI.

This is implemented as a subtype of StringValue even though xs:anyURI is not a subtype of xs:string in the XPath type hierarchy. This enables type promotion from URI to String to happen automatically in most cases where it is appropriate.

This implementation of xs:anyURI allows any string to be contained in the value space. It is possible to validate that the string is a "valid URI" in the sense of XML Schema Part 2 (which refers to the XLink specification and to RFC 2396); however, this validation is optional, and is not carried out by default. In particular, there is no constraint that namespace URIs, collation URIs, and the like should be valid URIs. However, casting from strings to xs:anyURI does invoke validation.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class net.sf.saxon.value.StringValue
`StringValue.CharacterIterator`

Field Summary
`static AnyURIValue` `EMPTY_URI`

Fields inherited from class net.sf.saxon.value.StringValue
`EMPTY_STRING, FALSE, length, SINGLE_SPACE, TRUE, value`

Fields inherited from class net.sf.saxon.value.AtomicValue
`typeLabel`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`AnyURIValue(java.lang.CharSequence value)` Constructor
`AnyURIValue(java.lang.CharSequence value, AtomicType type)` Constructor for a user-defined subtype of anyURI

Method Summary
`ConversionResult` `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`AtomicValue` `copyAsSubType(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`BuiltInAtomicType` `getPrimitiveType()` Determine the primitive type of the value.
`static boolean` `isValidURI(java.lang.CharSequence value)` Check whether a string consititutes a valid URI

Methods inherited from class net.sf.saxon.value.StringValue
`codepointEquals, containsSurrogatePairs, contract, convertStringToAtomicType, convertStringToBuiltInType, diagnosticDisplay, effectiveBooleanValue, equals, expand, expand, getSchemaComparable, getStringLength, getStringLength, getStringValue, getStringValueCS, getXPathComparable, isZeroLength, iterateCharacters, makeRestrictedString, makeStringValue, setStringValueCS, toString, validate`

Methods inherited from class net.sf.saxon.value.AtomicValue
`asAtomic, checkPermittedContents, convert, convert, getCardinality, getComponent, getItemType, getLength, getTypedValue, getTypeLabel, isNaN, itemAt, iterate, process, setTypeLabel, subsequence`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convertToJava, fromItem, getCanonicalLexicalRepresentation, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### EMPTY_URI

    public static final AnyURIValue EMPTY_URI

Constructor Detail

### AnyURIValue

    public AnyURIValue(java.lang.CharSequence value)

  Constructor

  Parameters:
    `value` - the String value. Null is taken as equivalent to "". This constructor does not check that the value is a valid anyURI instance.

### AnyURIValue

    public AnyURIValue(java.lang.CharSequence value,
                       AtomicType type)

  Constructor for a user-defined subtype of anyURI

  Parameters:
    `value` - the String value. Null is taken as equivalent to "".
    `type` - a user-defined subtype of anyURI. It is the caller's responsibility to ensure that this is actually a subtype of anyURI, and that the value conforms to the definition of this type.

Method Detail

### copyAsSubType

    public AtomicValue copyAsSubType(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Overrides:
    `copyAsSubType` in class `StringValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
  Returns:
    the copied value

### isValidURI

    public static boolean isValidURI(java.lang.CharSequence value)

  Check whether a string consititutes a valid URI

  Parameters:
    `value` - the string to be tested
  Returns:
    true if the string is a valid URI

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Description copied from class: `StringValue`
  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Overrides:
    `getPrimitiveType` in class `StringValue`
  Returns:
    the primitive type

### convertPrimitive

    public ConversionResult convertPrimitive(BuiltInAtomicType requiredType,
                                             boolean validate,
                                             XPathContext context)

  Convert to target data type

  Overrides:
    `convertPrimitive` in class `StringValue`
  Parameters:
    `requiredType` - integer code representing the item type required
    `context` - the XPath dynamic evaluation context
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    the result of the conversion, or an ErrorValue

Copyright (c) Saxonica Limited. All rights reserved.